Subject: Re: [PATCH] Use platform device for 8250 registration

From: Benjamin Herrenschmidt <[email-masked]>
Date: Wed, 17 Aug 2005 16:34:38 +1000

On Wed, 2005-08-17 at 01:30 -0500, Kumar Gala wrote:
> On Aug 16, 2005, at 11:21 AM, David Woodhouse wrote:
> 
> > My dual G4 PowerMac crashes sometimes when it probes for the (absent)
> > serial ports. Theoretically it's supposed to take a machine check and
> > recover -- but it doesn't always work like that.
> >
> > This patch removes the defaults from asm/pc_serial.h and uses the code
> > which already existed for ppc64 to register any ports which are  
> > found in
> > the device tree. It's slightly updated to work in 32-bit and also  
> > on the
> > Pegasos which claims the input frequency is 0Hz.
> >
> > We could probably remove all the rest of the crap from asm/serial.h  
> > and
> > let platforms register their own serial8250 platform devices. And this
> > probably breaks serial ports on PReP, which needs to do likewise.
> 
> Hmm, I wondering if we can provide some standard way of handling this  
> for the embedded platforms as well.  It would be nice to drop the old  
> style of initialization completely and move to using a platform  
> device always.

Sure, if they have a device-tree :) The code from ppc64 could be useable
there too. For others, they need to create their ports which whatever
mecanism they have to "know" where the port actually is ... little
common code here... but then, instanciating a platform device is easy.

Ben.